#ifndef _SYS_ENET_H
#define _SYS_ENET_H
#ident	"@(#)enet.h	1.2"
/*
 * Copyright (c) 1993 Addison-Wesley Publishing Company.
 * All rights reserved.  This source code is provided
 * for its instructional value, and is not guaranteed
 * for any particular purpose.
 */

#define MAXENET		16		/* number of minor devices */
#define EHDRSZ		14		/* size of ethernet header */
#define MAXDATA		1500		/* maximum user data per packet */
#define MINDATA		46		/* minimum user data per packet */
#define MACSZ		6		/* size of ethernet address */
#define SAPSZ		2		/* size of SAP identifier */
#define TOTADDRSZ	(MACSZ+SAPSZ)	/* total address size */

union protocol {
	uchar_t		b[2];
	ushort_t	s;
};

struct enethdr {
	uchar_t		dest[MACSZ];
	uchar_t		src[MACSZ];
	union protocol	prot;
};

#define ENETIOC	('E'<<8)
#define SETADDR	(ENETIOC|1)
#define GETADDR	(ENETIOC|2)

#ifdef _KERNEL

#define CMD_REG_ADDR	0x1000
#define SIZE_REG_ADDR	0x1004
#define STAT_REG_ADDR	0x1008
#define ENET_ADDR	0x100c
#define RECV_BUF_ADDR	0x2000
#define SEND_BUF_ADDR	0x3000

#define CMD_REG		(*(long *)CMD_REG_ADDR)
#define SIZE_REG	(*(long *)SIZE_REG_ADDR)
#define STAT_REG	(*(long *)STAT_REG_ADDR)

/* command register values */
#define SEND_PKT	0x01	/* send a packet */
#define RECV_OFF	0x02	/* shut off receiver */
#define RECV_ON		0x03	/* turn on receiver */
#define SET_ADDR	0x04	/* set ethernet address */

/* status register values */
#define RECV_PKT	0x01	/* packet has arrived */
#define SEND_DONE	0x02	/* packet has been sent */

#undef STATIC
#ifdef DEBUG
#define STATIC
#else
#define STATIC static
#endif

#endif /* _KERNEL */
#endif /* _SYS_ENET_H */
